#ifndef lint
static const char yysccsid[] = "@(#)yaccpar	1.9 (Berkeley) 02/21/93";
#endif

#include <stdlib.h>
#include <string.h>

#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYPATCH 20090221

#define YYEMPTY        (-1)
#define yyclearin      (yychar = YYEMPTY)
#define yyerrok        (yyerrflag = 0)
#define YYRECOVERING() (yyerrflag != 0)

/* compatibility with bison */
#ifdef YYPARSE_PARAM
/* compatibility with FreeBSD */
#ifdef YYPARSE_PARAM_TYPE
#define YYPARSE_DECL() yyparse(YYPARSE_PARAM_TYPE YYPARSE_PARAM)
#else
#define YYPARSE_DECL() yyparse(void *YYPARSE_PARAM)
#endif
#else
#define YYPARSE_DECL() yyparse(void)
#endif /* YYPARSE_PARAM */

extern int YYPARSE_DECL();

static int yygrowstack(void);
#define YYPREFIX "yy"
#line 2 "conf.y"
/*
 * $Id: conf.y,v 1.26 2005/04/17 15:20:32 nohar Exp $
 *
 * This file is part of the bip proproject
 * Copyright (C) 2004 Arnaud Cornet
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 */

#include <stdlib.h>
#include "util.h"
#include "irc.h"
#include "tuple.h"
extern int yylex (void);
extern char *yytext;
extern int linec;

#define YYMALLOC bip_malloc

extern int yyerror(char *);

int yywrap()
{
	return 1;
}

/*int yydebug = 1;*/

list_t *root_list;

struct tuple *tuple_i_new(int type, int i)
{
	struct tuple *t;
	t = bip_malloc(sizeof(struct tuple));
	t->type = type;
	t->ndata = i;
	t->tuple_type = TUPLE_INT;
	return t;
}

struct tuple *tuple_p_new(int type, void *p)
{
	struct tuple *t;
	t = bip_malloc(sizeof(struct tuple));
	t->type = type;
	t->pdata = p;
	return t;
}

struct tuple *tuple_s_new(int type, void *p)
{
	struct tuple *t = tuple_p_new(type, p);
	t->tuple_type = TUPLE_STR;
	return t;
}

struct tuple *tuple_l_new(int type, void *p)
{
	struct tuple *t = tuple_p_new(type, p);
	t->tuple_type = TUPLE_LIST;
	return t;
}

#line 73 "conf.y"
typedef union {
	int number;
	char *string;
	void *list;
	struct tuple *tuple;
} YYSTYPE;
#line 109 "conf.c"
#define LEX_IP 257
#define LEX_EQ 258
#define LEX_PORT 259
#define LEX_CSS 260
#define LEX_SEMICOLON 261
#define LEX_CONNECTION 262
#define LEX_NETWORK 263
#define LEX_LBRA 264
#define LEX_RBRA 265
#define LEX_USER 266
#define LEX_NAME 267
#define LEX_NICK 268
#define LEX_SERVER 269
#define LEX_PASSWORD 270
#define LEX_SRCIP 271
#define LEX_HOST 272
#define LEX_VHOST 273
#define LEX_SOURCE_PORT 274
#define LEX_NONE 275
#define LEX_COMMENT 276
#define LEX_BUNCH 277
#define LEX_REALNAME 278
#define LEX_SSL 279
#define LEX_SSL_CHECK_MODE 280
#define LEX_SSL_CHECK_STORE 281
#define LEX_SSL_CLIENT_CERTFILE 282
#define LEX_CHANNEL 283
#define LEX_KEY 284
#define LEX_LOG_ROOT 285
#define LEX_LOG_FORMAT 286
#define LEX_LOG_LEVEL 287
#define LEX_BACKLOG_LINES 288
#define LEX_BACKLOG_NO_TIMESTAMP 289
#define LEX_BACKLOG 290
#define LEX_LOG 291
#define LEX_LOG_SYSTEM 292
#define LEX_LOG_SYNC_INTERVAL 293
#define LEX_FOLLOW_NICK 294
#define LEX_ON_CONNECT_SEND 295
#define LEX_AWAY_NICK 296
#define LEX_PID_FILE 297
#define LEX_IGN_FIRST_NICK 298
#define LEX_ALWAYS_BACKLOG 299
#define LEX_BLRESET_ON_TALK 300
#define LEX_BLRESET_CONNECTION 301
#define LEX_DEFAULT_USER 302
#define LEX_DEFAULT_NICK 303
#define LEX_DEFAULT_REALNAME 304
#define LEX_NO_CLIENT_AWAY_MSG 305
#define LEX_BL_MSG_ONLY 306
#define LEX_ADMIN 307
#define LEX_BIP_USE_NOTICE 308
#define LEX_CSS_PEM 309
#define LEX_AUTOJOIN_ON_KICK 310
#define LEX_BOOL 311
#define LEX_INT 312
#define LEX_STRING 313
#define YYERRCODE 256
static const short yylhs[] = {                           -1,
    0,    0,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    2,    2,    8,    8,    8,    4,    4,   10,   10,
   10,   10,   10,   10,   10,   10,   10,   10,   10,   10,
   10,   10,   10,   10,   10,   10,    5,    5,   11,   11,
   11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
   11,   11,   11,   11,    3,    3,    9,    9,    9,    1,
    1,    7,    7,
};
static const short yylen[] = {                            2,
    0,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    4,
    4,    0,    3,    3,    3,    4,    0,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    3,    4,    0,    3,    3,    3,
    3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
    4,    3,    3,    3,    0,    3,    3,    3,    3,    0,
    3,    3,    3,
};
static const short yydefred[] = {                         1,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,   22,   27,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    2,    6,    7,    8,    0,    0,    3,    4,    5,   14,
   15,   16,   10,   11,   12,   13,   19,   17,   18,    9,
   20,    0,    0,    0,    0,    0,   21,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   70,    0,   23,   47,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   28,   24,    0,
   25,    0,   29,   30,   33,   34,   35,   39,   40,   41,
   45,   42,   43,   36,   37,   38,   44,   31,   32,    0,
   26,    0,    0,    0,   46,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   71,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   65,    0,    0,    0,    0,    0,    0,
   48,   73,   72,   50,   52,   49,   51,   54,   55,   56,
   53,   64,    0,   58,   62,   57,   59,   63,   60,   61,
    0,    0,    0,    0,    0,    0,    0,   66,   67,   68,
   69,
};
static const short yydgoto[] = {                          1,
  110,   45,  183,   46,  112,   21,  133,   65,  194,   85,
  151,
};
static const short yysindex[] = {                         0,
 -257, -251, -250, -245, -263, -260, -243, -242, -241, -238,
 -236, -235, -233, -232, -231, -221, -219, -217, -213, -211,
 -215, -265, -262, -252,    0,    0, -256, -253, -249, -248,
 -244, -230, -226, -220, -247, -240, -210, -209, -208, -237,
    0,    0,    0,    0, -255, -193,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, -188, -189, -180, -182, -184,    0, -168, -166, -164,
 -159, -158, -154, -153, -146, -142, -141, -140, -139, -138,
 -137, -136, -135, -134, -133, -187,    0, -186,    0,    0,
 -183, -181, -179, -178, -177, -185, -174, -173, -172, -171,
 -170, -169, -167, -165, -162, -161, -160,    0,    0, -254,
    0, -212,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -129,
    0, -127, -128, -116,    0, -115, -113, -111, -106, -105,
 -104, -103, -102, -107, -100,  -99,  -98,  -97,  -96,  -95,
  -94, -148, -147,    0, -145, -144, -143, -132, -131, -130,
 -126, -125, -124,    0, -121, -122, -120, -119, -118, -117,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, -246,    0,    0,    0,    0,    0,    0,    0,
  -93,  -87,  -86,  -88, -114, -112, -109,    0,    0,    0,
    0,
};
static const short yyrindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
static const short yygindex[] = {                         0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,
};
#define YYTABLESIZE 202
static const short yytable[] = {                          2,
   25,    3,    4,   26,  130,    5,   22,   23,    6,   61,
  131,   62,   24,   63,   27,   28,   29,  132,  190,   30,
  191,   31,   32,   64,   33,   34,   35,    7,    8,    9,
   10,   11,   12,   13,   14,   15,   36,  192,   37,   16,
   38,   17,   18,  193,   39,   41,   40,   42,   19,   43,
  134,   20,  135,  136,  137,  138,   47,  139,   44,   48,
  140,  141,   49,   50,   55,  142,   51,  143,   66,   86,
  144,   67,   56,   68,   87,   60,   69,   88,   89,   90,
   52,  145,  146,  147,   53,  148,   70,   71,   72,   91,
   54,   92,  149,   93,   73,   74,   75,  150,   94,   95,
   57,   58,   59,   96,   97,   76,   77,   78,   79,   80,
   81,   98,   82,   83,   84,   99,  100,  101,  102,  103,
  104,  105,  106,  107,  111,  109,  118,  108,  152,  113,
  153,  114,  154,  115,  116,  117,  119,  120,  121,  122,
  123,  155,  156,  124,  157,  125,  158,  126,  127,  128,
  129,  159,  160,  161,  162,  163,  164,  165,  166,  167,
  168,  169,  170,  172,  195,  173,  171,  174,  175,  176,
  196,  197,  198,    0,    0,    0,    0,    0,    0,    0,
  177,  178,  179,    0,    0,  180,    0,  181,  182,  184,
  185,  187,  186,  189,  188,    0,    0,    0,  199,    0,
  200,  201,
};
static const short yycheck[] = {                        257,
  264,  259,  260,  264,  259,  263,  258,  258,  266,  265,
  265,  267,  258,  269,  258,  258,  258,  272,  265,  258,
  267,  258,  258,  279,  258,  258,  258,  285,  286,  287,
  288,  289,  290,  291,  292,  293,  258,  284,  258,  297,
  258,  299,  300,  290,  258,  261,  258,  313,  306,  312,
  263,  309,  265,  266,  267,  268,  313,  270,  311,  313,
  273,  274,  312,  312,  312,  278,  311,  280,  262,  258,
  283,  265,  313,  267,  264,  313,  270,  258,  261,  264,
  311,  294,  295,  296,  311,  298,  280,  281,  282,  258,
  311,  258,  305,  258,  288,  289,  290,  310,  258,  258,
  311,  311,  311,  258,  258,  299,  300,  301,  302,  303,
  304,  258,  306,  307,  308,  258,  258,  258,  258,  258,
  258,  258,  258,  258,  311,  313,  312,  261,  258,  313,
  258,  313,  261,  313,  313,  313,  311,  311,  311,  311,
  311,  258,  258,  313,  258,  313,  258,  313,  311,  311,
  311,  258,  258,  258,  258,  258,  264,  258,  258,  258,
  258,  258,  258,  312,  258,  313,  261,  313,  313,  313,
  258,  258,  261,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  313,  313,  313,   -1,   -1,  312,   -1,  313,  313,  311,
  313,  311,  313,  311,  313,   -1,   -1,   -1,  313,   -1,
  313,  311,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 313
#if YYDEBUG
static const char *yyname[] = {

"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"LEX_IP","LEX_EQ","LEX_PORT",
"LEX_CSS","LEX_SEMICOLON","LEX_CONNECTION","LEX_NETWORK","LEX_LBRA","LEX_RBRA",
"LEX_USER","LEX_NAME","LEX_NICK","LEX_SERVER","LEX_PASSWORD","LEX_SRCIP",
"LEX_HOST","LEX_VHOST","LEX_SOURCE_PORT","LEX_NONE","LEX_COMMENT","LEX_BUNCH",
"LEX_REALNAME","LEX_SSL","LEX_SSL_CHECK_MODE","LEX_SSL_CHECK_STORE",
"LEX_SSL_CLIENT_CERTFILE","LEX_CHANNEL","LEX_KEY","LEX_LOG_ROOT",
"LEX_LOG_FORMAT","LEX_LOG_LEVEL","LEX_BACKLOG_LINES","LEX_BACKLOG_NO_TIMESTAMP",
"LEX_BACKLOG","LEX_LOG","LEX_LOG_SYSTEM","LEX_LOG_SYNC_INTERVAL",
"LEX_FOLLOW_NICK","LEX_ON_CONNECT_SEND","LEX_AWAY_NICK","LEX_PID_FILE",
"LEX_IGN_FIRST_NICK","LEX_ALWAYS_BACKLOG","LEX_BLRESET_ON_TALK",
"LEX_BLRESET_CONNECTION","LEX_DEFAULT_USER","LEX_DEFAULT_NICK",
"LEX_DEFAULT_REALNAME","LEX_NO_CLIENT_AWAY_MSG","LEX_BL_MSG_ONLY","LEX_ADMIN",
"LEX_BIP_USE_NOTICE","LEX_CSS_PEM","LEX_AUTOJOIN_ON_KICK","LEX_BOOL","LEX_INT",
"LEX_STRING",
};
static const char *yyrule[] = {
"$accept : commands",
"commands :",
"commands : commands command LEX_SEMICOLON",
"command : LEX_LOG_ROOT LEX_EQ LEX_STRING",
"command : LEX_LOG_FORMAT LEX_EQ LEX_STRING",
"command : LEX_LOG_LEVEL LEX_EQ LEX_INT",
"command : LEX_IP LEX_EQ LEX_STRING",
"command : LEX_PORT LEX_EQ LEX_INT",
"command : LEX_CSS LEX_EQ LEX_BOOL",
"command : LEX_CSS_PEM LEX_EQ LEX_STRING",
"command : LEX_LOG LEX_EQ LEX_BOOL",
"command : LEX_LOG_SYSTEM LEX_EQ LEX_BOOL",
"command : LEX_LOG_SYNC_INTERVAL LEX_EQ LEX_INT",
"command : LEX_PID_FILE LEX_EQ LEX_STRING",
"command : LEX_BACKLOG_LINES LEX_EQ LEX_INT",
"command : LEX_BACKLOG_NO_TIMESTAMP LEX_EQ LEX_BOOL",
"command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"command : LEX_BLRESET_ON_TALK LEX_EQ LEX_BOOL",
"command : LEX_BL_MSG_ONLY LEX_EQ LEX_BOOL",
"command : LEX_ALWAYS_BACKLOG LEX_EQ LEX_BOOL",
"command : LEX_NETWORK LEX_LBRA network LEX_RBRA",
"command : LEX_USER LEX_LBRA user LEX_RBRA",
"network :",
"network : network net_command LEX_SEMICOLON",
"net_command : LEX_NAME LEX_EQ LEX_STRING",
"net_command : LEX_SSL LEX_EQ LEX_BOOL",
"net_command : LEX_SERVER LEX_LBRA server LEX_RBRA",
"user :",
"user : user usr_command LEX_SEMICOLON",
"usr_command : LEX_NAME LEX_EQ LEX_STRING",
"usr_command : LEX_PASSWORD LEX_EQ LEX_STRING",
"usr_command : LEX_ADMIN LEX_EQ LEX_BOOL",
"usr_command : LEX_BIP_USE_NOTICE LEX_EQ LEX_BOOL",
"usr_command : LEX_SSL_CHECK_MODE LEX_EQ LEX_STRING",
"usr_command : LEX_SSL_CHECK_STORE LEX_EQ LEX_STRING",
"usr_command : LEX_SSL_CLIENT_CERTFILE LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_USER LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_NICK LEX_EQ LEX_STRING",
"usr_command : LEX_DEFAULT_REALNAME LEX_EQ LEX_STRING",
"usr_command : LEX_BACKLOG_LINES LEX_EQ LEX_INT",
"usr_command : LEX_BACKLOG_NO_TIMESTAMP LEX_EQ LEX_BOOL",
"usr_command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"usr_command : LEX_BLRESET_ON_TALK LEX_EQ LEX_BOOL",
"usr_command : LEX_BLRESET_CONNECTION LEX_EQ LEX_BOOL",
"usr_command : LEX_BL_MSG_ONLY LEX_EQ LEX_BOOL",
"usr_command : LEX_ALWAYS_BACKLOG LEX_EQ LEX_BOOL",
"usr_command : LEX_CONNECTION LEX_LBRA connection LEX_RBRA",
"connection :",
"connection : connection con_command LEX_SEMICOLON",
"con_command : LEX_NAME LEX_EQ LEX_STRING",
"con_command : LEX_NETWORK LEX_EQ LEX_STRING",
"con_command : LEX_NICK LEX_EQ LEX_STRING",
"con_command : LEX_USER LEX_EQ LEX_STRING",
"con_command : LEX_REALNAME LEX_EQ LEX_STRING",
"con_command : LEX_PASSWORD LEX_EQ LEX_STRING",
"con_command : LEX_VHOST LEX_EQ LEX_STRING",
"con_command : LEX_SOURCE_PORT LEX_EQ LEX_INT",
"con_command : LEX_AWAY_NICK LEX_EQ LEX_STRING",
"con_command : LEX_FOLLOW_NICK LEX_EQ LEX_BOOL",
"con_command : LEX_IGN_FIRST_NICK LEX_EQ LEX_BOOL",
"con_command : LEX_AUTOJOIN_ON_KICK LEX_EQ LEX_BOOL",
"con_command : LEX_CHANNEL LEX_LBRA channel LEX_RBRA",
"con_command : LEX_ON_CONNECT_SEND LEX_EQ LEX_STRING",
"con_command : LEX_NO_CLIENT_AWAY_MSG LEX_EQ LEX_STRING",
"con_command : LEX_SSL_CHECK_MODE LEX_EQ LEX_STRING",
"channel :",
"channel : channel cha_command LEX_SEMICOLON",
"cha_command : LEX_NAME LEX_EQ LEX_STRING",
"cha_command : LEX_KEY LEX_EQ LEX_STRING",
"cha_command : LEX_BACKLOG LEX_EQ LEX_BOOL",
"server :",
"server : server ser_command LEX_SEMICOLON",
"ser_command : LEX_HOST LEX_EQ LEX_STRING",
"ser_command : LEX_PORT LEX_EQ LEX_INT",

};
#endif
#if YYDEBUG
#include <stdio.h>
#endif

/* define the initial stack-sizes */
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH  YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 500
#define YYMAXDEPTH  500
#endif
#endif

#define YYINITSTACKSIZE 500

int      yydebug;
int      yynerrs;
int      yyerrflag;
int      yychar;
short   *yyssp;
YYSTYPE *yyvsp;
YYSTYPE  yyval;
YYSTYPE  yylval;

/* variables for the parser stack */
static short   *yyss;
static short   *yysslim;
static YYSTYPE *yyvs;
static unsigned yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack(void)
{
    int i;
    unsigned newsize;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;

    i = yyssp - yyss;
    newss = (yyss != 0)
          ? (short *)realloc(yyss, newsize * sizeof(*newss))
          : (short *)malloc(newsize * sizeof(*newss));
    if (newss == 0)
        return -1;

    yyss  = newss;
    yyssp = newss + i;
    newvs = (yyvs != 0)
          ? (YYSTYPE *)realloc(yyvs, newsize * sizeof(*newvs))
          : (YYSTYPE *)malloc(newsize * sizeof(*newvs));
    if (newvs == 0)
        return -1;

    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT  goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR  goto yyerrlab

int
YYPARSE_DECL()
{
    int yym, yyn, yystate;
#if YYDEBUG
    const char *yys;

    if ((yys = getenv("YYDEBUG")) != 0)
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = YYEMPTY;
    yystate = 0;

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    yystate = 0;
    *yyssp = 0;

yyloop:
    if ((yyn = yydefred[yystate]) != 0) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        yystate = yytable[yyn];
        *++yyssp = yytable[yyn];
        *++yyvsp = yylval;
        yychar = YYEMPTY;
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;

    yyerror("syntax error");

    goto yyerrlab;

yyerrlab:
    ++yynerrs;

yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                yystate = yytable[yyn];
                *++yyssp = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = YYEMPTY;
        goto yyloop;
    }

yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    if (yym)
        yyval = yyvsp[1-yym];
    else
        memset(&yyval, 0, sizeof yyval);
    switch (yyn)
    {
case 1:
#line 88 "conf.y"
	{ yyval.list = root_list = list_new(NULL); }
break;
case 2:
#line 89 "conf.y"
	{ list_add_last(yyvsp[-2].list, yyvsp[-1].tuple); yyval.list = yyvsp[-2].list; }
break;
case 3:
#line 93 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_LOG_ROOT, yyvsp[0].string); }
break;
case 4:
#line 94 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_LOG_FORMAT,
						yyvsp[0].string); }
break;
case 5:
#line 96 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG_LEVEL, yyvsp[0].number); }
break;
case 6:
#line 97 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_IP, yyvsp[0].string); }
break;
case 7:
#line 98 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_PORT, yyvsp[0].number); }
break;
case 8:
#line 99 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_CSS, yyvsp[0].number); }
break;
case 9:
#line 100 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_CSS_PEM, yyvsp[0].string); }
break;
case 10:
#line 101 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG, yyvsp[0].number); }
break;
case 11:
#line 102 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_LOG_SYSTEM, yyvsp[0].number); }
break;
case 12:
#line 103 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_LOG_SYNC_INTERVAL, yyvsp[0].number); }
break;
case 13:
#line 105 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PID_FILE, yyvsp[0].string); }
break;
case 14:
#line 107 "conf.y"
	{
	           yyval.tuple = tuple_i_new(LEX_BACKLOG_LINES, yyvsp[0].number);
		  }
break;
case 15:
#line 110 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BACKLOG_NO_TIMESTAMP, yyvsp[0].number);
	       }
break;
case 16:
#line 113 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yyvsp[0].number); }
break;
case 17:
#line 114 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_ON_TALK, yyvsp[0].number);
	       }
break;
case 18:
#line 117 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BL_MSG_ONLY, yyvsp[0].number);
	       }
break;
case 19:
#line 120 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_ALWAYS_BACKLOG, yyvsp[0].number); }
break;
case 20:
#line 123 "conf.y"
	{ yyval.tuple = tuple_l_new(LEX_NETWORK,
						yyvsp[-1].list); }
break;
case 21:
#line 125 "conf.y"
	{ yyval.tuple = tuple_l_new(LEX_USER, yyvsp[-1].list); }
break;
case 22:
#line 128 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 23:
#line 129 "conf.y"
	{ list_add_last(yyvsp[-2].list, yyvsp[-1].tuple); yyval.list = yyvsp[-2].list; }
break;
case 24:
#line 132 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yyvsp[0].string); }
break;
case 25:
#line 133 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_SSL, yyvsp[0].number); }
break;
case 26:
#line 134 "conf.y"
	{
			yyval.tuple = tuple_l_new(LEX_SERVER, yyvsp[-1].list); }
break;
case 27:
#line 138 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 28:
#line 139 "conf.y"
	{ list_add_last(yyvsp[-2].list, yyvsp[-1].tuple); yyval.list = yyvsp[-2].list; }
break;
case 29:
#line 142 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_NAME, yyvsp[0].string); }
break;
case 30:
#line 144 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PASSWORD,
		yyvsp[0].string); }
break;
case 31:
#line 146 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_ADMIN, yyvsp[0].number); }
break;
case 32:
#line 147 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_BIP_USE_NOTICE, yyvsp[0].number); }
break;
case 33:
#line 149 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_MODE, yyvsp[0].string); }
break;
case 34:
#line 151 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_STORE, yyvsp[0].string); }
break;
case 35:
#line 153 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CLIENT_CERTFILE, yyvsp[0].string); }
break;
case 36:
#line 155 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_USER, yyvsp[0].string); }
break;
case 37:
#line 157 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_NICK, yyvsp[0].string); }
break;
case 38:
#line 159 "conf.y"
	{
		   yyval.tuple = tuple_s_new(LEX_DEFAULT_REALNAME, yyvsp[0].string); }
break;
case 39:
#line 161 "conf.y"
	{
	           yyval.tuple = tuple_i_new(LEX_BACKLOG_LINES, yyvsp[0].number);
		  }
break;
case 40:
#line 164 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BACKLOG_NO_TIMESTAMP, yyvsp[0].number);
	       }
break;
case 41:
#line 167 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yyvsp[0].number); }
break;
case 42:
#line 168 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_ON_TALK, yyvsp[0].number);
	       }
break;
case 43:
#line 171 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BLRESET_CONNECTION, yyvsp[0].number);
	       }
break;
case 44:
#line 174 "conf.y"
	{
	       yyval.tuple = tuple_i_new(LEX_BL_MSG_ONLY, yyvsp[0].number);
	       }
break;
case 45:
#line 177 "conf.y"
	{ yyval.tuple = tuple_i_new(
						LEX_ALWAYS_BACKLOG, yyvsp[0].number); }
break;
case 46:
#line 179 "conf.y"
	{
				 yyval.tuple = tuple_l_new(LEX_CONNECTION, yyvsp[-1].list); }
break;
case 47:
#line 183 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 48:
#line 184 "conf.y"
	{
	       list_add_last(yyvsp[-2].list, yyvsp[-1].tuple); yyval.list = yyvsp[-2].list; }
break;
case 49:
#line 188 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yyvsp[0].string); }
break;
case 50:
#line 189 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NETWORK,
			 yyvsp[0].string); }
break;
case 51:
#line 191 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NICK, yyvsp[0].string); }
break;
case 52:
#line 192 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_USER, yyvsp[0].string); }
break;
case 53:
#line 193 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_REALNAME,
		 yyvsp[0].string); }
break;
case 54:
#line 195 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_PASSWORD,
		 yyvsp[0].string); }
break;
case 55:
#line 197 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_VHOST, yyvsp[0].string); }
break;
case 56:
#line 198 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_SOURCE_PORT, yyvsp[0].number); }
break;
case 57:
#line 200 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_AWAY_NICK,
						yyvsp[0].string); }
break;
case 58:
#line 202 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_FOLLOW_NICK, yyvsp[0].number); }
break;
case 59:
#line 204 "conf.y"
	{ yyval.tuple = tuple_i_new(
					   LEX_IGN_FIRST_NICK, yyvsp[0].number); }
break;
case 60:
#line 206 "conf.y"
	{
		   yyval.tuple = tuple_i_new(LEX_AUTOJOIN_ON_KICK, yyvsp[0].number); }
break;
case 61:
#line 208 "conf.y"
	{ yyval.tuple = tuple_l_new(
						LEX_CHANNEL, yyvsp[-1].list); }
break;
case 62:
#line 210 "conf.y"
	{ yyval.tuple = tuple_s_new(
						LEX_ON_CONNECT_SEND, yyvsp[0].string); }
break;
case 63:
#line 212 "conf.y"
	{ yyval.tuple = tuple_s_new(
						LEX_NO_CLIENT_AWAY_MSG, yyvsp[0].string); }
break;
case 64:
#line 214 "conf.y"
	{ yyval.tuple = tuple_s_new(
			LEX_SSL_CHECK_MODE, yyvsp[0].string); }
break;
case 65:
#line 217 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 66:
#line 218 "conf.y"
	{ list_add_last(yyvsp[-2].list, yyvsp[-1].tuple); yyval.list = yyvsp[-2].list; }
break;
case 67:
#line 221 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_NAME, yyvsp[0].string); }
break;
case 68:
#line 222 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_KEY, yyvsp[0].string); }
break;
case 69:
#line 223 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_BACKLOG, yyvsp[0].number); }
break;
case 70:
#line 226 "conf.y"
	{ yyval.list = list_new(NULL); }
break;
case 71:
#line 227 "conf.y"
	{ list_add_last(yyvsp[-2].list, yyvsp[-1].tuple); yyval.list = yyvsp[-2].list; }
break;
case 72:
#line 230 "conf.y"
	{ yyval.tuple = tuple_s_new(LEX_HOST, yyvsp[0].string); }
break;
case 73:
#line 231 "conf.y"
	{ yyval.tuple = tuple_i_new(LEX_PORT, yyvsp[0].number); }
break;
#line 975 "conf.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = (short) yystate;
    *++yyvsp = yyval;
    goto yyloop;

yyoverflow:
    yyerror("yacc stack overflow");

yyabort:
    return (1);

yyaccept:
    return (0);
}
